unit TetrisDM;

{$include RELEASE_SETTINGS.INC}
{$include DAV_Compiler.inc}
{$include VSTPLUGIN_SWITCHES.INC}

interface

uses 
  {$IFDEF FPC} 
  Interfaces,
  {$ELSE}
  Windows,
  {$ENDIF}
  Classes, Forms, SysUtils, 
  DAV_VSTModule, DAV_VSTEffect, DAV_VSTCustomModule, DAV_Types;
  

type
  { TTetrisModule }
  TTetrisModule = class(TVSTModule)
    function DataModuleCheckKey(Sender: TObject; Key: Char): Boolean;
    procedure DataModuleCreate(Sender: TObject);
    procedure DataModuleEditOpen(Sender: TObject; var GUI: TForm; ParentWindow: THandle);
    procedure DataModuleEditorKeyDown(Sender: TObject; var keyCode: TVstKeyCode);
    procedure DataModuleProcess(const Inputs,
      Outputs: TDAVArrayOfSingleFixedArray; const SampleFrames: Cardinal);
  private
    //
  public
    //
  end;


implementation

{$IFnDEF FPC}
  {$R *.dfm}
{$ELSE}
  {$R *.lfm}
{$ENDIF}

uses TetrisEditor;


function TTetrisModule.DataModuleCheckKey(Sender: TObject; Key: Char): Boolean;
begin
 result:= True;
end;

procedure TTetrisModule.DataModuleCreate(Sender: TObject);
begin
 // Whyever, the Property Editor throws away the following assignments.
 // So I forced them manually here :
 OnProcess:= {@}DataModuleProcess;
end;

procedure TTetrisModule.DataModuleEditOpen(Sender: TObject; var GUI: TForm;
  ParentWindow: THandle);
begin
  GUI:= TFmTetris.Create(Self);
end;

procedure TTetrisModule.DataModuleEditorKeyDown(Sender: TObject;
  var keyCode: TVstKeyCode);
begin
 if assigned(EditorForm) then
  with (EditorForm As TFmTetris) do
   begin
    case keyCode.Character of
     VKEY_SPACE : Tetris.StepGame;
     VKEY_LEFT  : Tetris.Left;
     VKEY_right : Tetris.Right;
     VKEY_up    : Tetris.Rotate;
     VKEY_DOWN  : Tetris.StepGame;
    end;
    FormPaint(nil);
   end;
end;

procedure TTetrisModule.DataModuleProcess(const Inputs,
  Outputs: TDAVArrayOfSingleFixedArray; const SampleFrames: Cardinal);
var i, j : Integer;
begin
 for i:= 0 to 1 do
  for j:= 0 to sampleframes - 1 do
   outputs[i]^[j]:= inputs[i]^[j];
end;


end.
